// Copyright 2005, Google Inc.
//
// Redistribution and use in source and binary forms, with or without 
// modification, are permitted provided that the following conditions are met:
//
//  1. Redistributions of source code must retain the above copyright notice, 
//     this list of conditions and the following disclaimer.
//  2. Redistributions in binary form must reproduce the above copyright notice,
//     this list of conditions and the following disclaimer in the documentation
//     and/or other materials provided with the distribution.
//  3. Neither the name of Google Inc. nor the names of its contributors may be
//     used to endorse or promote products derived from this software without
//     specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
// EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
// OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
// OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#include "domstubs.idl"
#include "base_interface_ff.idl" // XPIDL doesn't like slashes in #includes

interface nsIVariant;
interface GearsResultSetInterface;


[scriptable, uuid(93FF2CCE-7332-4702-831F-8E45A8D791E0)]
interface GearsDatabaseInterface : GearsBaseClassInterface {
  void open(//OPTIONAL in AString database_name
           );
  GearsResultSetInterface execute(//in AString expr
                                  //OPTIONAL in nsIVariant arg_array
                                 );
  void close();

  readonly attribute PRInt64 lastInsertRowId;

m4_changequote(`^',`^')m4_dnl
m4_ifdef(^DEBUG^,^m4_dnl
  readonly attribute long executeMsec;
^)
};


[scriptable, uuid(A195DFB3-22E7-4ea9-ACF9-B2F505212E98)]
interface GearsResultSetInterface : GearsBaseClassInterface {
  nsIVariant field(in long index);
  nsIVariant fieldByName(in AString field_name);
  AString fieldName(in long index);
  long fieldCount();
  void close();
  void next();
  boolean isValidRow();
};
